'##############################################################
'bewegungssensor1.bas
'
'Ein kleines Testprogramm fr RN-AVR UNIVERSAL (ATMega644)
'und Bewegungssenor PIR SE10 von Robotikhardware.de
'Das Programm demonstriert wie man mit einem kleinem
'kompakten PIR-Sensor Bewegung in einem Raum erkennen kann
'Sobald die geringste Bewegung erkannt wird, wird dies ber RS232 ausgegeben
'Die Led leuchtet ebenfalls bei Bewegung auf
'
' (c) Frank Brall 2013
'Weitere Beispiele auf DVD von robotikhardware.de
'oder im www.Roboternetz.de und rn-wissen.de

'######################################################################

'Portbelegung:
'PIR SE10 Alarmkontakt an PA0
'PIR GND nach GND
'PIR + nach POW+ (Batterie 4 Mignon)
'Pullup-Widerstand 33k von PA0 nach POW+
'Werteausgabe ber RS232/USB


Declare Function PIRAbfragen()  as byte


$programmer = 12                    'MCS USB  (Zeile weglassen wenn anderer Programmer)
$prog &HFF , &HFF , &HD9 , &HFE      'Fusebits richtig programmieren (Quarz ein,Jtag aus)

$regfile = "m644pdef.dat" ' oder $regfile = "m644def.dat"
$framesize = 64
$swstack = 64
$hwstack = 64

$crystal = 8000000                                          'Quarzfrequenz


Config Pind.6 = Output                                      'LED
Led1 Alias Portd.6


Config Pina.0 = Input
Config Adc = Single , Prescaler = auto , Reference = INTERNAL_1.1



dim bewegung as byte

Start Adc
wait 3  '2 Sekunden warten - kalibrierung Sensor auf Hintergrund
Do
    bewegung= PIRAbfragen()
    if bewegung=1 then print "Bewegung wurde erkannt !"
    waitms 100
Loop



Function PIRAbfragen()  as byte
local adcwert as  Integer

    adcwert=Getadc(0)
    if adcwert<1023 then
      bewegung=1
      Led1=0
    else
      bewegung=0
      Led1=1
    endif
end function